/**
 * Copyright (C) 2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.perseus.concurrency.api;

/**
 * Signal that the concurrency manager asks the rolling back of the transaction
 * 
 * @author S.Chassande-Barrioz
 */
public class RolledBackConcurrencyException extends ConcurrencyException {

    public RolledBackConcurrencyException() {
    }

    public RolledBackConcurrencyException(String msg) {
        super(msg);
    }

    public RolledBackConcurrencyException(Exception nested) {
        super(nested);
    }

    public RolledBackConcurrencyException(String msg, Exception nested) {
        super(msg, nested);
    }
}
