package org.objectweb.perseus.concurrency.distributed.globallock.lib;


/**
 * Copyright (C) 2003-2004
 * - France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR AE PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 1.0
 *
 * Authors: Olivier Lobry (olivier.lobry@rd.francetelecom.com)
 *
 */


import org.objectweb.perseus.distribution.api.DistResCoordinator;
import org.objectweb.perseus.distribution.api.DistResCoordinatorService;
import org.objectweb.perseus.distribution.api.DistResCoordinatorFactory;
import org.objectweb.perseus.concurrency.distributed.globallock.lib.GlobalLockCoordinator;
import org.objectweb.perseus.concurrency.lib.LockValue;
import org.objectweb.perseus.concurrency.lib.RWLockValue;

import java.io.Serializable;

/**
 * This class creates one coordinator per each global lock
 */

public class GlobalLockCoordinatorFactory implements DistResCoordinatorFactory {
	LockValue lockValue;
	public GlobalLockCoordinatorFactory() {
		this(new RWLockValue());
	}
	public GlobalLockCoordinatorFactory(LockValue lockValue) {
		this.lockValue = lockValue;
	}
	public DistResCoordinator newCoordinator(DistResCoordinatorService drcs,
											 Serializable nodeId, Object copy,
											 Object resId) {
		GlobalLockCoordinator glc;

		if (copy == null) {
			glc = new GlobalLockCoordinator(resId, drcs, lockValue);
		} else {
			glc = (GlobalLockCoordinator) copy;
			glc.initCopy(resId, drcs, lockValue);
		}

		return glc;
	}
}
