package org.objectweb.perseus.concurrency.distributed.globallock;

import org.objectweb.perseus.concurrency.distributed.globallock.api.GlobalLock;
import org.objectweb.perseus.concurrency.distributed.globallock.api.GlobalLockException;
import org.objectweb.perseus.concurrency.distributed.globallock.lib.BasicGlobalLockManager;
import org.objectweb.perseus.concurrency.distributed.globallock.lib.GlobalLockUser;
import org.objectweb.perseus.distribution.api.DistResServiceManager;
import org.objectweb.perseus.distribution.api.DistResCoordinatorFactory;
import org.objectweb.perseus.distribution.util.MessageEventListenerRegistry;
import java.io.Serializable;

/**
 * Copyright (C) 2003-2004
 * - France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 1.0
 *
 * Authors: lobry
 * Date: 14 juin 2004
 * Time: 11:08:13
 */
public class GlobalLockManagerInterceptor extends BasicGlobalLockManager {
	MessageEventListenerRegistry reg;
	
	public GlobalLockManagerInterceptor(DistResServiceManager drsm,
										DistResCoordinatorFactory drcf,
										MessageEventListenerRegistry reg) {
		super(drsm, drcf);
		this.reg = reg;
	}


	protected GlobalLock createLock(Serializable resId) {
		GlobalLockUser gl = (GlobalLockUser) super.createLock(resId);
		GlobalLockInterceptor gli = new GlobalLockInterceptor(gl, reg);
		return gli;
	}

	protected void joinUsers(Serializable oid) throws GlobalLockException {
		GlobalLockInterceptor gli = (GlobalLockInterceptor) distlocks.get(oid);
		UserInterceptor ui = new UserInterceptor(gli.glu, nodeId);
		try {
			drus.joinUsers(oid, ui);
		} catch (Exception e) {
			throw new GlobalLockException(e);
		}
	}


}
