package org.objectweb.perseus.concurrency.distributed.globallock;

import org.objectweb.perseus.concurrency.distributed.util.action.KillNode;
import org.objectweb.perseus.distribution.api.DistResServiceManager;

import java.util.Iterator;
import java.util.Set;
import java.util.HashSet;
import java.io.Serializable;

/**
 * Copyright (C) 2003-2004
 * - France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 1.0
 *
 * Authors: lobry
 * Date: 11 juin 2004
 * Time: 12:31:37
 */
public class KillNodeAndWait extends KillNode
 implements GlobalLockInterceptor.FailureListener {
	Set notHandled = new HashSet();
	public KillNodeAndWait(String name, DistResServiceManager drsm, Object node,
						   Serializable resId) {
		super(name, drsm, node);
		Set nodes = new HashSet(drsm.getLocalNodes());
		nodes.remove(node);
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			Object n = it.next();
			notHandled.add(n);
			Object ui = drsm.getUserService(n).getUser(resId);
			((UserInterceptor) ui).setFailureListener(this);

		}
	}

	public synchronized void perform() throws Exception {
		super.perform();
		while (!notHandled.isEmpty()) {
			wait();
		}
		em.notifyEvent(endEvent, true);
	}

	public synchronized void handle(Serializable resId, Serializable nodeId) {
		notHandled.remove(nodeId);
		if (notHandled.isEmpty()) notify();
	}
}
