/**
 * Copyright (C) 2003-2004
 * - France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR AE PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 1.0
 *
 * Authors: Olivier Lobry (olivier.lobry@rd.francetelecom.com)
 *
 */

package org.objectweb.perseus.concurrency.distributed.globallock;

import org.objectweb.perseus.concurrency.distributed.AbstractLockingAction;
import org.objectweb.perseus.concurrency.distributed.globallock.api.GlobalLock;

public class Upgrade extends AbstractLockingAction {
	GlobalLockInterceptor h;
	boolean waitNotGrantable;

	public Upgrade(GlobalLockInterceptor h,  byte expBehaviour,
					 byte execMode, byte lck, boolean waitNotGrantable) {
		super(h.getName(), expBehaviour, execMode, lck);
		this.h = h;
		this.waitNotGrantable = waitNotGrantable;
	}


	protected void performBlockingAction() throws Exception {

		if (waitNotGrantable)
			while (h.getGrantable() >= lck) Thread.sleep(100);

		/* GlobalLockWaiterImpl w = h.upgrade(lck, false); */
		h.upgrade(lck, true, 0);
/*		handledByUser();
		if (w != null) {
			boolean ok = w.waitLock(0);
			if (!ok) {
				if (h.trace) h.trace("WAKE UP TIMED OUT (Waiting: " + lck + ")");
				te.addException(new DeadLockException());
			}
			if (h.trace) h.trace("WAKE UP (Waiting: " + lck + ")");
			return;
		}
		*/
	}

 		final public String getBrief() {
			return "U";
		}

		protected String getLockingDescription() {
			return "upgrade";
		}

}
