package org.objectweb.perseus.concurrency.distributed.globallock;

import org.objectweb.perseus.distribution.api.DistResUser;
import java.io.Serializable;

public class UserInterceptor implements DistResUser {
	DistResUser dru;
	GlobalLockInterceptor.FailureListener failureListener;
	Serializable nodeId;

	public UserInterceptor(DistResUser dru, Serializable nodeId) {
		this.dru = dru;
		this.nodeId = nodeId;
	}

	public void receive(Serializable resId, Serializable message) {
		dru.receive(resId, message);
	}

	public Serializable getState(Serializable resId) {
		Serializable ret = dru.getState(resId);
		if (failureListener != null)
			failureListener.handle(resId, nodeId);
		return ret;
	}

	public void setFailureListener(GlobalLockInterceptor.FailureListener failureListener) {
		this.failureListener = failureListener;
	}
}
